SystemOrganization addCategory: #FuelCommandLineHandler!

CommandLineHandler subclass: #FuelCommandLineHandler
	instanceVariableNames: 'files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelCommandLineHandler'!

!FuelCommandLineHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/4/2012 22:16'!
commandName
	^ 'Fuel'! !

!FuelCommandLineHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/4/2012 22:16'!
description
	^ 'Handles fuel files'! !

!FuelCommandLineHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/4/2012 22:19'!
fileExtension
	^ '.fuel'! !

!FuelCommandLineHandler classSide methodsFor: 'handler selection' stamp: 'MarianoMartinezPeck 8/4/2012 22:18'!
isResponsibleFor: aCommandLine
	"This handler is reponsible only for .fuel files"
	(aCommandLine hasFileWithExtension: self fileExtension)
		ifTrue: [ ^ true ].
	^ super isResponsibleFor: aCommandLine
	! !

!FuelCommandLineHandler methodsFor: 'activation' stamp: 'MarianoMartinezPeck 8/4/2012 22:03'!
activate
	self manageFiles.
	(self commandLine hasOption: 'save')
		ifTrue: [
			ThreadSafeTranscript install.
			Smalltalk addDeferredStartupAction: [
				Smalltalk snapshot: true andQuit: true.
				NonInteractiveTranscript new install.
			]
		].
	(self commandLine hasOption: 'quit')
		ifTrue: [ self exitSucess ].! !

!FuelCommandLineHandler methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/4/2012 22:14'!
fileExtension
	^ self class fileExtension! !

!FuelCommandLineHandler methodsFor: 'manage' stamp: 'MarianoMartinezPeck 8/4/2012 23:46'!
manageFile: aFileReference

	aFileReference readStreamDo: [ :stream |
		stream binary.
		FileStream stdout nextPutAll: 'Materializing from file: ', aFileReference fullName; lf.
		FLMaterializer new materializeFrom: stream.
		FileStream stdout nextPutAll: 'Materialization finished'; lf.
		].! !

!FuelCommandLineHandler methodsFor: 'manage' stamp: 'MarianoMartinezPeck 8/5/2012 21:44'!
manageFiles
	"Load all the source files in the given array."
	[files := (self commandLine allFilesWithExtension: self fileExtension)
		 collect: [ :each | (FileSystem disk resolve: each) asFileReference ].
	files ifNil: [ ^self ].
	files do: [ :reference | self manageFile: reference ] 
	] ensure: [ files := nil ].
! !
